package rs.core;

interface CoreInterface {
  String callExtension(String name, String params);
  String getExtensions();
  boolean isExtensionsLoaded();
  void reloadExtensions();
  void fireNfc(in Tag tag);
  String  getDeviceModel();
  void showExtensionSettings(String name);
  void unloadExtension(String name);
  byte [] readFile(String extension,String name);
  boolean isDeviceAvailable(String name);
  boolean isDeviceEnable(String name);
  void setDeviceEnabled(String name, boolean on);
  void subscribe(String receiver);
  void unsubscribe(String receiver);
  void nfcWrite(String map);
  String nfcWriteMap();
  void nfcWriteDone(String id, String message);
  String availableDevices();
  Intent getResultIntent(String name);
  String getDeviceId();
  String getDeviceSerial();
  boolean setNFCKey(String key);
}