package rs.core.hw;

import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.DialogInterface;
import android.util.Pair;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import settings.NotNull;
import settings.SettingsField;

public class BasePrinterConfig {

	@NotNull
	@SettingsField(name="driver",hidden=true)
	public String DRIVER;
	@SettingsField(description="Адрес",name="address",options="{\"pick\":\"btChoose\"}")
	@NotNull
	public String ADDRESS;
	@SettingsField(description="Ширина бумаги, мм",name="width")
	public int WIDTH = 58;
	@SettingsField(description="Высота этикетки, мм\n(-1 для ленты)",name="width")
	public int HEIGHT = -1;

	
	public BasePrinterConfig() {
	}
	
	public void btChoose(final View v) {
		Context ctx = v.getContext();
		BluetoothAdapter adapter = BluetoothAdapter.getDefaultAdapter();
		if(adapter != null) {
			final ArrayAdapter<Pair<String,String>> list = new ArrayAdapter<Pair<String,String>>(ctx, android.R.layout.simple_list_item_1) {
				@Override
				public View getView(int position, View convertView, ViewGroup parent) {
					View v = super.getView(position, convertView, parent);
					Pair<String,String> p = getItem(position);
					((TextView)v).setText(p.second+"\n"+p.first);
					return v;
				}
			};
			for(BluetoothDevice d : adapter.getBondedDevices())
				list.add( new Pair<String,String>(d.getAddress(),d.getName()));
			AlertDialog.Builder b = new AlertDialog.Builder(ctx);
			b.setAdapter(list, new DialogInterface.OnClickListener() {
				
				@Override
				public void onClick(DialogInterface arg0, int position) {
					Pair<String,String> p = list.getItem(position);
					((TextView)v).setText(p.first);
				}
			});
			b.create().show();
		}
		
	}

}
