package settings;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
public @interface SettingsField {
	public String name();
	public int descrId() default 0;
	public int order() default 65535;
	public String description() default "";
	public String options() default "";
	public String type() default "";
	public boolean hidden() default false;
	public Class<?> elementClass() default EmptySettings.class;
}
