package rs.core.example.ui;

import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.lang.reflect.Array;
import java.net.Inet4Address;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.util.Collection;
import java.util.Collections;

import rs.core.example.R;
import rs.core.example.exchange.ExchangeServer;
import android.app.Fragment;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

public class DataExchange extends Fragment implements
		ExchangeServer.DataListener {
	private ExchangeServer _server;
	private TextView _ips, _info;
	private Handler _handler;
	private File _f;
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		View v = inflater.inflate(R.layout.exchange, container, false);
		_f = new File(getActivity().getCacheDir(),"data");
		_f.mkdir();
		_ips = (TextView) v.findViewById(R.id.lbl_ips);
		_info = (TextView) v.findViewById(R.id.lbl_info);
		_handler = new Handler(getActivity().getMainLooper()) {
			private FileOutputStream _fos;
			private int _rcvd;
			@Override
			public void handleMessage(Message msg) {
				String s = _info.getText().toString();
				switch(msg.what) {
				case ExchangeServer.CMD_PUT_FIRST:
						s+= "Начато получение данных";
						_rcvd = 0;
						try {
							_fos = new FileOutputStream(new File(_f,String.format("%d.xml", System.currentTimeMillis())));
						} catch(IOException ioe) {
							_fos = null;
						}
						break;
				case ExchangeServer.CMD_PUT:
					if(msg.arg1 > 0) {
						s+=".";
						_rcvd += msg.arg1;
						if(_fos != null) try {
							_fos.write((byte []) msg.obj);
						} catch(IOException ioe) { }
					}
					break;
				case ExchangeServer.CMD_PUT_LAST:
					if(_fos != null) try {
						_fos.close();
						_fos = null;
					} catch(IOException ioe) { }
					s+= String.format("\nДанные загружены, %d kb\n",(_rcvd/1024));
				}
				_info.setText(s);

			}
		};
		_server = new ExchangeServer(this);
		return v;
	}

	@Override
	public void onStart() {
		super.onStart();
		new Thread() {
			public void run() {
				try {
					final StringBuilder sb = new StringBuilder();
					for (NetworkInterface nif : Collections
							.list(NetworkInterface.getNetworkInterfaces())) {
						for (InetAddress addr : Collections.list(nif
								.getInetAddresses())) {
							if (addr instanceof Inet4Address
									&& !addr.isLoopbackAddress()) {
								if (sb.length() > 0)
									sb.append("\n");
								sb.append(addr.getHostAddress());
							}

						}
					}
					_handler.post(new Runnable() {
						@Override
						public void run() {
							_ips.setText(sb.toString());
						}
					});
				} catch (IOException ioe) {

				}
			};
		}.start();
		_server.start();
	}

	@Override
	public void onStop() {
		super.onStop();
		_server.stop();
	}

	@Override
	public void onData(byte command, byte[] data, int size) {
		Message msg = _handler.obtainMessage(command);
		if(data != null && size > 0) {
			msg.obj = new byte[size];
			System.arraycopy(data, 0, msg.obj, 0, size);
			msg.arg1 = size;
		}
		_handler.sendMessage(msg);
	}
}
