package rs.core.example.ui;

import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import android.app.ListActivity;
import android.os.Bundle;
import android.widget.ArrayAdapter;
import android.widget.Toast;

public class XmlViewer extends ListActivity {

    ArrayList<String> xmlList = new ArrayList<String>();
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        try
        {
            InputStream is= new FileInputStream(getIntent().getStringExtra("Data"));
            DocumentBuilder builder= DocumentBuilderFactory.newInstance().newDocumentBuilder();
            Document doc=builder.parse(is, null);
            NodeList nodes=doc.getChildNodes();
            if(nodes != null && nodes.getLength() > 0) {
                xmlList.clear();
                int len = nodes.getLength();
                for(int i = 0; i < len; ++i) {
                    addNode(nodes.item(i),"");
                }
            }
            ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, xmlList);
            setListAdapter(adapter);
        }
        catch(Throwable t){
            Toast.makeText(this, "Exception :" + t.toString(), Toast.LENGTH_LONG).show();
        }
    }
    private void addNode(Node n, String offset) {
    	if("Record".equals(n.getNodeName())) {
    		xmlList.add(n.getAttributes().getNamedItem("Name").getNodeValue()+" "+n.getAttributes().getNamedItem("BarCode").getNodeValue());
    	}
    	
    	for(int i=0;i<n.getChildNodes().getLength();i++)
    		addNode(n.getChildNodes().item(i),offset+" ");
    }
}